// C Source File
// Created 06.08.2001; 13:15:45

// To do
// - String zeilenumbruch

// For use withe DOORS (auskommentieren von OPTIMIZE_ROM_CALLS, SAVE_SCREEN)
// Doesn't Save Space or gives better performance
// #define USE_KERNEL         // Make Kernel Program

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files

// My define 
#define URHEBER "GNUScroll V0.9 by Daniel Keller"
#define NUM_CHR_PER_LINES 60  // Anzahl Charakter je Linie (fr Malloc)
                              // Anzahl Zeichen (Nummern) TI-89: F_6x8: 24 (fix Fontlnge)
                              //                                 F_4x6: 37 (var Fontlnge)
                              //              (Schtzung) TI-92: F_6x8: 36 (fix Fontlnge)
                              //                                 F_4x6: 56 (var Fontlnge)

#define KBD_DELAY 15          // Scrollgeschwindigkeit

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File


void finalize(short delay1, short delay2, void *UrheberS, void *virtual, char *str, short VirtualScreen)
{
	if (VirtualScreen)
		PortRestore (); 

	// Memory wieder frei geben
	if (str != NULL)
		free (str); 
	if (virtual != NULL)
		free (virtual);
	if (UrheberS != NULL)
		free (UrheberS);

 // Keyboard wieder herstellen
	OSInitKeyInitDelay     (delay1);
	OSInitBetweenKeyDelay  (delay2);
}

void error(int ScreenWidth, short delay1, short delay2, void *UrheberS, void *virtual, char *str, short VirtualScreen)
{
	int num_lines;
	SCR_RECT rect;
	
	num_lines = DrawStrWidth("NOT ENOUGH MEMORY", F_6x8)+4;
	rect = (SCR_RECT){{floor((ScreenWidth-num_lines)/2), 10, floor((ScreenWidth-num_lines)/2)+num_lines, 26}};
	ScrRectFill (&rect, &rect, A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(floor((ScreenWidth-num_lines)/2)+2, 14, "NOT ENOUGH MEMORY", A_REVERSE);
		
	if (VirtualScreen)
		memcpy (LCD_MEM, virtual, LCD_SIZE);
	ngetchx();
	
	finalize(delay1, delay2, UrheberS, virtual, str, VirtualScreen);
}

// Main Function
void _main(void)
{
	unsigned long i, j;
	unsigned int argtype, anzZeilen, firstprint, ScreenHeight, ScreenWidth, numRows, scboxHeight, scboxPos, leftOffset, topOffset, ScreenHeightA, SC_FONT, urheberWidth, num_lines;
	signed int scrollrows, pos;
	int moveblocksize, y0, y1;
	char buffer[NUM_CHR_PER_LINES+1];
	char *str;
	void *virtual, *UrheberS; 
	short key, delay1, delay2;
	SCR_RECT rect, rectU, rectB;
  ESI argptr, argback;

// Rechner abfragen
	if (CALCULATOR == 0) // Wenn TI-89 160 * 100
	{
		ScreenHeight  = 92;
		ScreenHeightA = 99;
		ScreenWidth   = 160;
		numRows       = 11;
		topOffset     = 4;
		leftOffset    = 2;
	}
	else // Wenn TI-92 Plus 240 * 128
	{
		ScreenHeight  = 120;
		ScreenHeightA = 127;
		ScreenWidth   = 240;
		numRows       = 15;
		topOffset     = 1;
		leftOffset    = 2;
	}

// Kbd Delay
	delay1 = OSInitKeyInitDelay     (KBD_DELAY);
	delay2 = OSInitBetweenKeyDelay  (KBD_DELAY);
	
// Screen initialisieren
	SC_FONT   = F_4x6;
	virtual   = NULL;
	UrheberS  = NULL;
	str       = NULL;

  ClrScr();
  FontSetSys(SC_FONT);
	virtual  = calloc (30, 128);
	UrheberS = calloc (30, 5);
	if (virtual == NULL || UrheberS == NULL)
	{
		error(ScreenWidth, delay1, delay2, UrheberS, virtual, str, FALSE);
		return;
	}
	PortSet (virtual, 239, 127);

  urheberWidth = ScreenWidth - DrawStrWidth(URHEBER, F_4x6) - 1;
	rectU = (SCR_RECT){{0, ScreenHeightA-5, ScreenWidth, ScreenHeightA}};	
	rectB = (SCR_RECT){{ScreenWidth-7, 0, ScreenWidth-1, ScreenHeight}};


	// Urheberinfo aufbereiten
	ScrRectFill (&rectU, &rectU, A_NORMAL);
  FontSetSys(F_4x6);
	DrawStr(urheberWidth, ScreenHeightA-5, URHEBER, A_REVERSE);
  FontSetSys(SC_FONT);
	memcpy (UrheberS, virtual+3690, 150);

	// Argumente auslesen
  InitArgPtr(argptr);

	j=0;
	anzZeilen = 0;
	num_lines = 0;
	while((argtype=GetArgType(argptr))!=END_TAG) // Wenn es ein String ist
	{
		if(argtype==217 && j==1) // Wenn es eine Liste ist
		{     		
			argback = argptr;
			argptr  = argptr - 1;
			while((argtype=GetArgType(argptr))!=END_TAG) // Wenn es ein String ist
			{
				if(argtype==STR_TAG && num_lines>anzZeilen)
				{     	
					strncpy (buffer, GetStrnArg(argptr), NUM_CHR_PER_LINES); 
					memcpy(str + anzZeilen*(NUM_CHR_PER_LINES+1), buffer, (unsigned long)strlen(buffer));
					anzZeilen++;
				}
				else
					SkipArg(argptr);
			}
			argptr = argback;
			SkipArg(argptr);
		}

		else if(j==2 && argtype==POSINT_TAG) // Anzahl Zeilen
		{
			if (GetIntArg(argptr)==1)
				SC_FONT = F_6x8;	
			else
				SC_FONT = F_4x6;
			FontSetSys(SC_FONT);
		}
		else if(j==2 && argtype==FLOAT_TAG)  // Anzahl Zeilen
		{
			if (GetFloatArg(argptr)==1)
				SC_FONT = F_6x8;	
			else
				SC_FONT = F_4x6;
			FontSetSys(SC_FONT);
		}
		
		else if(j==0 && (argtype==POSINT_TAG || argtype==FLOAT_TAG)) // Anzahl Zeilen
		{
			if (argtype==POSINT_TAG)
				num_lines = GetIntArg(argptr);
			else if (argtype==FLOAT_TAG)
				num_lines = (int)GetFloatArg(argptr);
				
			str = (char *)calloc((NUM_CHR_PER_LINES+1), num_lines);
			if (str==NULL)
			{
				error(ScreenWidth, delay1, delay2, UrheberS, virtual, str, TRUE);
				return;
			}
		}
		else
			SkipArg(argptr);

		j++;
	}

	if (anzZeilen > 0)
	{
// Scrollbox
	if (anzZeilen < numRows)
  	scboxHeight = ScreenHeight-1;	
	else
  	scboxHeight = floor(ScreenHeight * numRows / anzZeilen);

// Ausgabe
		if (anzZeilen <= numRows)
			firstprint = anzZeilen;
		else
			firstprint = numRows;

	  for (i=0; i<firstprint; i++)
			DrawStr(leftOffset, topOffset+i*8, str+i*(NUM_CHR_PER_LINES+1), A_NORMAL);

		key = 0;
		pos = 0;

		while(key != 264) // Solange nicht ESC gedrckt
		{
		// Scrollbar zeichnen
			ScrRectFill (&rectB, &rectB, A_NORMAL);

			if (anzZeilen>numRows)
				scboxPos = floor((ScreenHeight-scboxHeight-1) * pos / (anzZeilen-numRows));
			else
				scboxPos = 0;			

			rect = (SCR_RECT){{ScreenWidth-6, 1+scboxPos, ScreenWidth-2, scboxPos+scboxHeight}};
			ScrRectFill (&rect, &rect, A_REVERSE);


		// Version Zeichnen
			memcpy (virtual+3690, UrheberS, 150);

		// Bildschirm kopieren
			memcpy (LCD_MEM, virtual, LCD_SIZE);

		
			key = ngetchx();
			scrollrows = 0;
			if (key == (short)KEY_UP)
				scrollrows = -1;
			else if (key == (short)KEY_DOWN)
				scrollrows = 1;			
			else if (key == (short)KEY_UP   + (short)KEY_DIAMOND)
				scrollrows = -pos;			
			else if (key == (short)KEY_DOWN + (short)KEY_DIAMOND)
				scrollrows = anzZeilen - numRows - pos;
			else if (key == (short)KEY_UP   + 4096)
				scrollrows = -(numRows-2);	
			else if (key == (short)KEY_DOWN + 4096)
				scrollrows = +(numRows-2);
		
			if (pos + scrollrows + (signed)numRows > (int signed)anzZeilen)
				 scrollrows = anzZeilen - numRows - pos;
			if (pos + scrollrows < 0)
				scrollrows = -pos;

			if (anzZeilen <= numRows)
				scrollrows = 0;

			// Scrollen
			if (scrollrows != 0)
			{			
				if (abs(scrollrows) < (signed)numRows)
				{
					if (scrollrows < 0) // upscroll
					{
						y0 = 0;
						y1 = ScreenHeight + 8 * scrollrows;
						moveblocksize = 240 * (y1 - y0) / 8;
						memmove(virtual+(ScreenHeight-y1)*240/8, virtual, moveblocksize);
						rect = (SCR_RECT){{0, 0, ScreenWidth-8, abs(scrollrows)*8-1}};
						ScrRectFill (&rect, &rect, A_REVERSE);
						pos += scrollrows;
						for (i=0; i<(unsigned)abs(scrollrows); i++)
							DrawStr(leftOffset, topOffset+i*8, str+(pos + i)*(NUM_CHR_PER_LINES+1), A_NORMAL);
					}		
					else // downscroll
					{
						y0 = scrollrows * 8;
						y1 = ScreenHeight;
						moveblocksize = 240 * (y1 - y0) / 8;
						memmove(virtual, virtual+y0*240/8, moveblocksize);
						rect = (SCR_RECT){{0, y1-y0, ScreenWidth-8, ScreenHeight}};
						ScrRectFill (&rect, &rect, A_REVERSE);
						pos += scrollrows;
						for (i=0; i<(unsigned)scrollrows; i++)
							DrawStr(leftOffset, topOffset+(numRows-(scrollrows-i))*8, str+(pos + numRows - scrollrows + i)*(NUM_CHR_PER_LINES+1), A_NORMAL);
					}		
				}
				else
				{
					rect = (SCR_RECT){{0, 0, ScreenWidth-8, ScreenHeight}};
					ScrRectFill (&rect, &rect, A_REVERSE);
					pos += scrollrows;
			  	for (i=0; i<numRows; i++)
						DrawStr(leftOffset, topOffset+i*8, str+(pos + i)*(NUM_CHR_PER_LINES+1), A_NORMAL);
				}
			}
		}	
	}
	finalize(delay1, delay2, UrheberS, virtual, str, TRUE);
}
